<?xml version='1.0' encoding='UTF-8' ?>
<!--
  ~ Copyright (c) 2016 Roman Nazarenko.
  ~
  ~  This program is free software: you can redistribute it and/or modify
  ~  it under the terms of the GNU Affero General Public License as
  ~  published by the Free Software Foundation, either version 3 of
  ~  the License, or (at your option) any later version.
  ~
  ~  This program is distributed in the hope that it will be useful,
  ~  but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~  GNU General Public License for more details.
  ~
  ~  You should have received a copy of the GNU General Public License
  ~  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  -->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
		"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
	  xmlns:h="http://xmlns.jcp.org/jsf/html"
	  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	  xmlns:f="http://xmlns.jcp.org/jsf/core" xmlns:c="http://java.sun.com/jsp/jstl/core"
	  xmlns:of="http://omnifaces.org/functions"
>

<h:head>
	<ui:include src="/WEB-INF/jsf/include/title.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/imports.xhtml"/>
	<ui:include src="/WEB-INF/jsf/include/init.xhtml"/>
</h:head>
<h:outputScript>

	$(function () {
		jsf.ajax.addOnEvent(function (event) {
			if (event.status === 'success') {
				registerMarkdownEditor();
				initializeDatePicker();
			}
		});
		registerMarkdownEditor();
		initializeDatePicker();
	});

	function registerMarkdownEditor() {
		$('#editArticleFormId\\:markdownTextArea').markdown({
			resize: 'vertical',
			height: 1200,
		});
	}

	function initializeDatePicker() {
		$('.date-picker-field').each(function () {
			var element = $(this);
			var value = element.attr('content');
			element.datepicker({
				showButtonPanel: true,
				dateFormat: 'mm/dd/yy',
			});
			if (value) {
				element.datepicker('setDate', value);
			}
		});
	}

</h:outputScript>
<h:body styleClass="pushable">
	<div class="pusher">
		<div class="ui container framed">
			<ui:include src="/WEB-INF/jsf/include/header.xhtml"/>

			<div class="ui centered two columns footer-margin grid">
				<div class="ui thirteen wide column">
					<div class="ui raised segment">
						<h1>Uploaded images</h1>
						<h:form id="imageUploadFormId"
								styleClass="ui ${errorUtils.formClass(component)} form"
								enctype="multipart/form-data">
							<div class="field">
								<label>Image caption</label>
								<h:inputText value="#{fileUploadBean.description}"
											 validatorMessage="Description too long, max ${fileUploadBean.maxDescriptionSize} characters">
									<f:passThroughAttribute name="placeholder" value="Image caption"/>
									<f:validateLength maximum="${fileUploadBean.maxDescriptionSize}"/>
								</h:inputText>
							</div>
							<div class="field">
								<h:inputFile value="#{fileUploadBean.file.part}">
									<f:validateLength maximum="${fileUploadBean.maxFileSize}"/>
								</h:inputFile>
							</div>
							<div class="ui success message">
								Image uploaded
							</div>
							<div class="ui error message">
								<div class="header">Error:</div>
								<h:messages showDetail="true" showSummary="false"/>
							</div>
							<h:commandButton styleClass="ui primary button" value="Upload"
											 action="#{fileUploadBean.upload}">
								<f:ajax execute="@form" render=":imageUploadFormId :imagesListFormId"/>
							</h:commandButton>
						</h:form>
						<div class="ui divider"></div>
						<h:form id="imagesListFormId" styleClass="ui form">
							<div class="ui four cards">
								<ui:repeat value="${filesListBean.imagesPage}" var="image">
									<div class="card">
										<div class="image">
											<h:graphicImage url="/image/dynamic/${image.id}.png"
															alt="${image.description}"/>
										</div>
										<div class="content">
											<div class="description">
												<h:commandButton styleClass="ui right floated small red button"
																 value="Delete"
																 action="#{filesListBean.delete(image.id)}">
													<f:ajax render=":imagesListFormId"/>
												</h:commandButton>
												${image.description}
											</div>
										</div>
										<div class="extra content">
											<h:outputText styleClass="local-date-time"
														  value="${image.uploaded.toInstant().toEpochMilli()}"/>
										</div>
									</div>
								</ui:repeat>
							</div>
						</h:form>
						<div class="ui right floated basic compact segment">
							<div class="ui right pagination menu">
								<ui:repeat value="#{of:createIntegerArray(1, filesListBean.pagesCount)}"
										   var="i"
										   varStatus="loop">
									<c:set var="isCurrent" value="${paginationUtils.isCurrent(loop.index)}"/>
									<h:link styleClass="item"
											outcome="${view.viewId}"
											rendered="${not isCurrent}">
										${i}
										<f:param name="${paginationUtils.pageParameter}" value="${loop.index}"/>
									</h:link>
									<h:panelGroup styleClass="active item" rendered="${isCurrent}">
										${i}
									</h:panelGroup>
								</ui:repeat>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
		<ui:include src="/WEB-INF/jsf/include/footer.xhtml"/>
	</div>
</h:body>
</html>

